SuperStrict
Framework brl.standardio
Import brl.blitz
Import brl.filesystem
Import brl.stream
Import brl.retro



Global path$="code.txt"
If AppArgs.length>1 Then
	Local ona%=0
	For Local a$=EachIn AppArgs
		ona:+1
		If ona=2 Then path=a
	Next
EndIf



Global code@[1]

Local fil:TStream=ReadFile(path)
If Not fil Print "Could not load "+path;Input;End

Global size:Long=0

Local index:Long=0
Global cmds$="<>+-.,()@#%"
Repeat
	Local lin$=ReadLine(fil)
	For Local s%=1 To Len(lin)
		If Instr(cmds,Mid(lin,s,1))
			size:+1
			code=code[..size]
			code[size-1]=Asc(Mid(lin,s,1))
		EndIf
	Next
Until Eof(fil)
CloseFile fil




Global memory@[64],msize:Long=64
Global mmod:Long=0
Function get@(x:Long)
	If x+mmod<0 Then 
		mmod=-x;memory=memory[..msize+mmod]
		For Local rsize%=0 To msize+mmod-2
			memory[msize+mmod-1-rsize]=memory[msize+mmod-2-rsize]
		Next
		memory[0]=0
	EndIf
	If x=>msize Then msize:+1;memory=memory[..msize+mmod]
	If x+mmod<0
		Print msize+mmod
		Print x+mmod
	EndIf
	Return memory[x+mmod]
End Function
Function set(x:Long,s@)
	get x
	memory[x+mmod]=s
End Function




'get(mem+0)*1+get(mem+1)*2+get(mem+2)*4+get(mem+3)*8+get(mem+4)*16+get(mem+5)*32+get(mem+6)*64+get(mem+7)*128
'get(mem+0)*128+get(mem+1)*64+get(mem+2)*32+get(mem+3)*16+get(mem+4)*8+get(mem+5)*4+get(mem+6)*2+get(mem+7)*1

Print "Executing "+path
Print ""


Global pos%=0,mem%=36,skip%=0
Repeat
	If pos=>size Exit
	If skip
		skip=0
	Else
		Select Chr(code[pos])
			Case "+" set(mem,get(mem)+1)
			Case "-" set(mem,get(mem)-1)
			Case "." WriteStdout get(mem)
			Case "," set(mem,Asc(ReadStdin()))
			Case "<" mem:-1
			Case ">" mem:+1
			Case "(" 'do nothing
			Case ")" 'do nothing
			Case "@"
				Local kill%=0
				Repeat
					pos:+1
					If pos=>size Then kill=1;Exit
				Until Chr(code[pos])=")"
				If kill Then Exit
			Case "#"
				If get(mem)>0 skip=1
			Case "%"
				Local start%=0
				Repeat
					pos:-1
					If pos=0 start=1;Exit
				Until Chr(code[pos])="("
		End Select
	EndIf
	pos:+1
Forever



Print ""
Print ""
Print "Execution complete."
Input
End







